package main;
class TwoTuple<A,B> {
    
    A a;
    B b;

    public TwoTuple(A a,B b) {
	this.a = a;
	this.b = b;
    }

    public A getA() {
	return a;
    }

    public void setA(A a) {
	this.a = a;
    }

    public B getB() {
	return b;
    }

    public void setB(B b) {
	this.b = b;
    }
    
    public boolean equals(Object o)  {
	if(o == null || getClass() != o.getClass()) {
	    return false;
	} else {
	    @SuppressWarnings("unchecked")
		TwoTuple<Object,Object> that = (TwoTuple<Object,Object>)o;
	    boolean ae = (this.a == null ? that.a == null : this.a.equals(that.a));
	    boolean be = (this.b == null ? that.b == null : this.b.equals(that.b));
	    return ae && be;
	}
	
    }
    
    public int hashCode() {
	int ah = (a == null ? 1 : a.hashCode());
	int bh = (b == null ? 1 : b.hashCode());
	return ah * bh;
    }
}