package main;
public class GraphWalkerNodeDetails {


    /* Filled in by parent (/child) in a forward (/backward) walk */
    public boolean revisit;
    public boolean usedlink;
    public boolean firstnode;
    public boolean firstrelative;
    public boolean lastrelative;
    public int     relativenumber;
    public int     depth;
    public GraphWalker.ParentState pstate;



    /* Filled in by node */
    public GraphWalker.NodeState nstate;

    public GraphWalkerNodeDetails() {
	revisit        = false;
	usedlink       = false;
	firstnode      = false;
	firstrelative  = false;
	lastrelative   = false;
	relativenumber = -1;
	depth          = -1;
    }

    public String toString() {
	StringBuffer b = new StringBuffer();
	b.append(pstate+", ");
	b.append(nstate+", ");
	b.append(revisit ? "revisit, " : "newvisit, ");
	b.append(firstnode ? "root, " : "");
	b.append(firstrelative ? "first, " : "");
	b.append(lastrelative ? "last, " : "");
	return b.toString();
    }
}
