package main;
import java.util.*;

class SpohnNodeFactory implements NetworkNodeFactory {
	
    int r;
    int k;

    int nodenumber = 0;

    public SpohnNodeFactory(int k, int r) {
        this.k = k;
        this.r = r;
    }
	
    public NetworkNode newNode(Network network) {
        return new SpohnNode(network, new SpohnData(getNodeNumber(), k, r));
    }
	
    public NetworkNode newNode(int id) {
        return new SpohnNode(null, new SpohnData(id, k, r));
    }

     public String toJavaCodeString(String variablename) {
         MyStringBuffer b = new MyStringBuffer();
         b.appendln("int k = "+k+";");
         b.appendln("int r = "+r+";");
         b.appendln("NetworkNodeFactory "+variablename+" = new SpohnNodeFactory(k, r);");
         return b.toString();
     }

     String coordToName(Coordinate c) {
         return ""+getNodeNumber();
     }

    int getNodeNumber() {
        return nodenumber++;
    }
	
}
